# Source code for group 29 bachelor's thesis

## About the project
This is the source code for the bachelor's thesis "Azure Cloud Cost Prediction: Monolithic and Multi-Model Approaches".

#### Team members:
    - Aleksander Brekke Røed
    - Erlend Rønning

## Abstract
In this bachelor's thesis, we explore the use of a monolithic and a multi-model machine learning approach to predict cloud pricing for Azure services, focusing on custom-tailored models. The research utilizes various factors influencing cloud prices such as type, region, demand, and market trends. The goal is to explore and determine the effectiveness of these machine learning models in the context of SkyeTec AS's customer data. By developing accurate and reliable cloud pricing prediction models, the study aims to contribute insights into the area of cloud cost prediction, potentially helping in the optimization of cloud expenses.

#### Repository:

https://github.com/alekmann/Bachelor29

## Summary of implementations
The source code includes the code for implementations and visualizations of two approaches to machine learning for Azure cloud cost prediction.<br>
Structure of the repoistory:
<br>
* Helpers: Contains the logic of the implementations, and functions for preprocessing and visualiztion.
* Results: CSV-files with the results of the model fittings.
* Data: Dataset of raw Azure data.
* Images: Visualizations are saved to this directory.
* Models: Contains the models saved during fitting.
* Demo.py: Example of how to use the functions in the helpers.
* Main.py: Calls the demo functions.
  <br>

## Installation guide
1. Verify your Python 3 and pip installations. Visit https://www.python.org/downloads/ for the latest version.
```console
$ python --version
$ pip --version
```

2. Use requirements.txt to install the required pip packages by running this line of code in your terminal.

```console
$ pip install -r requirements.txt
```

3. Place your Azure dataset in the "data"-folder. Structure of the folder:
<br>
data/ <br>
├── 2022-01/ <br>
│   ├── 2022-01-01.json <br>
│   ├── 2022-01-02.json <br>
│   ├── ... <br>
│   └── 2022-01-31.json <br>
├── 2022-02/ <br>
│   ├── 2022-02-01.json <br>
│   ├── 2022-02-02.json <br>
│   ├── ... <br>
│   └── 2022-02-28.json <br>
├── 2022-03/ <br>
│   ├── 2022-03-01.json <br>
│   ├── 2022-03-02.json <br>
│   ├── ... <br>
│   └── 2022-03-31.json <br>
├── ... <br>
└── 2022-12/ <br>
    ├── 2022-12-01.json <br>
    ├── 2022-12-02.json <br>
    ├── ... <br>
    └── 2022-12-31.json <br>
<br>
