import pandas as pd
import os
import json

def get_path(year, month, date):
    if month < 10:
        month = f'0{month}'
    if date < 10:
        date = f'0{date}'
    return f'data/{year}-{month}/{year}-{month}-{date}.json'

def load_data_from_date(year, month, date):
    path = get_path(year, month, date)
    f = open(path)
    data = json.load(f)
    return data

def generate_df(data):
    columns = []
    for i in data[0]['Columns']:
        columns.append(i['Name'])
    df = pd.DataFrame(data[0]['Rows'], columns=columns)
    for i in range(2, len(data)):
        df2 = pd.DataFrame(data[i]['Rows'], columns=columns)
        df = pd.concat([df, df2], ignore_index=True)
    return df

def get_all_data():
    df_arr = []
    for i in range(1, 13):
        j = 1
        while os.path.isfile(get_path(2022, i, j)):
            data = load_data_from_date(2022, i, j)
            df = generate_df(data)
            df_arr.append(df)
            j += 1
    return df_arr

def combine_data(data):
    combined_data = pd.concat(data, ignore_index=True)
    return combined_data

def split_data(df_types, combined_data, types):
    for i in range(len(df_types)):
        df_types[i] = combined_data[combined_data['ResourceType'] == types[i]]
    return df_types